Index: sources/app/src/main/java/parkup/entities/ParkingZone.java
===================================================================
--- sources/app/src/main/java/parkup/entities/ParkingZone.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/entities/ParkingZone.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -1,3 +1,5 @@
 package parkup.entities;
+
+import parkup.data.ParkingZoneLocation;
 
 import javax.persistence.*;
@@ -10,8 +12,8 @@
     @Id
     @SequenceGenerator(
-            name="parking_zone_generator",
+            name="parking_zone_sequence_generator",
             sequenceName = "parking_zone_sequence",
             allocationSize = 1,
-            initialValue = 500
+            initialValue = 600
     )
     @GeneratedValue(    //za postgres treba sequence da se namesti i ime na generator mi ga davamo kako od gore sto e
@@ -31,8 +33,11 @@
     private int capacity;
 
-    @Column(name = "work_hours")
-    private String workHours;
+    @Column(name = "vreme_od")  //za rabotni casovi od:
+    private int from;
 
-    @Column(name = "location")
+    @Column(name = "vreme_do")    //za rabotni casovi do:
+    private int to;
+
+    @Column(name = "lokacija")
     private String location;
 
@@ -40,32 +45,51 @@
     private int zafateniMesta;
 
+    @Column(name = "color")
+    private String color;
+
+    @ManyToMany(cascade = {CascadeType.ALL})
+    @JoinColumn(name="odgovorniLica",nullable = true)
+    private List<Vraboten> odgovorniLica;
+
     @OneToMany(cascade = {CascadeType.ALL})
-    @JoinColumn(name = "parkingSpaces", nullable = false)
     private List<ParkingSpace> parkingSpaces;
 
-    public ParkingZone() {
+    @OneToOne(cascade = {CascadeType.ALL})
+    private ParkingZoneLocation parkingZoneLocation;
+
+   public ParkingZone() {
+       this.zafateniMesta = 0;
+       this.parkingSpaces = new ArrayList<ParkingSpace>();
+   }
+
+    public ParkingZone(String pzName) {
+        this.pzName = pzName;
         this.zafateniMesta = 0;
         this.parkingSpaces = new ArrayList<ParkingSpace>();
     }
 
-    public ParkingZone(int pzId, String pzName, int price, int capacity, String workHours, String location, List<ParkingSpace> parkingSpaces) {
+    public ParkingZone(int pzId, String pzName, int price, int capacity, String location, List<ParkingSpace> parkingSpaces, String color, int from, int to) {
         this.pzId = pzId;
         this.pzName = pzName;
         this.price = price;
         this.capacity = capacity;
-        this.workHours = workHours;
         this.location = location;
         this.zafateniMesta = 0;
         this.parkingSpaces = parkingSpaces;
+        this.color = color;
+        this.from = from;
+        this.to = to;
     }
 
-    public ParkingZone(String pzName, int price, int capacity, String workHours, String location, List<ParkingSpace> parkingSpaces) {
+    public ParkingZone(String pzName, int price, int capacity, String location, List<ParkingSpace> parkingSpaces, String color, int from, int to) {
         this.pzName = pzName;
         this.price = price;
         this.capacity = capacity;
-        this.workHours = workHours;
         this.location = location;
         this.zafateniMesta = 0;
         this.parkingSpaces = parkingSpaces;
+        this.color = color;
+        this.from = from;
+        this.to = to;
     }
 
@@ -102,12 +126,4 @@
     }
 
-    public String getWorkHours() {
-        return this.workHours;
-    }
-
-    public void setWorkHours(String workHours) {
-        this.workHours = workHours;
-    }
-
     public String getLocation() {
         return this.location;
@@ -125,3 +141,43 @@
 
     public void setParkingSpaces(List<ParkingSpace> parkingSpaces) {this.parkingSpaces = parkingSpaces;}
+
+    public String getColor() {
+        return color;
+    }
+
+    public void setColor(String color) {
+        this.color = color;
+    }
+
+    public int getFrom() {
+        return from;
+    }
+
+    public void setFrom(int from) {
+        this.from = from;
+    }
+
+    public int getTo() {
+        return to;
+    }
+
+    public void setTo(int to) {
+        this.to = to;
+    }
+
+    public ParkingZoneLocation getParkingZoneLocation() {
+        return parkingZoneLocation;
+    }
+
+    public void setParkingZoneLocation(ParkingZoneLocation parkingZoneLocation) {
+        this.parkingZoneLocation = parkingZoneLocation;
+    }
+
+    public List<Vraboten> getOdgovorniLica() {
+        return odgovorniLica;
+    }
+
+    public void setOdgovorniLica(List<Vraboten> odgovorniLica) {
+        this.odgovorniLica = odgovorniLica;
+    }
 }
Index: sources/app/src/main/java/parkup/entities/RegistriranParkirac.java
===================================================================
--- sources/app/src/main/java/parkup/entities/RegistriranParkirac.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/entities/RegistriranParkirac.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -2,12 +2,17 @@
 
 import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
 import java.util.List;
 import javax.persistence.*;
 
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+import org.springframework.security.core.userdetails.UserDetails;
 import parkup.data.Tablicka;
 
 @Entity
 @Table(name = "registriranParkirac")
-public class RegistriranParkirac {
+public class RegistriranParkirac implements UserDetails {
     @Id
     @SequenceGenerator(
@@ -33,5 +38,5 @@
     private String password;
 
-    @OneToMany
+    @OneToMany(cascade ={CascadeType.ALL})
     @Column(name = "regTablicki")
     private List<Tablicka> regTablicki;
@@ -46,8 +51,11 @@
     private String role;
 
+    private boolean locked;
+
+    private boolean enabled;
+
     public RegistriranParkirac() {
-
         this.regTablicki = new ArrayList<Tablicka>();
-        this.role = "ROLE_REGISTIRAN_PARKIRAC";
+        this.role = "ROLE_REGISTRIRAN_PARKIRAC";
     }
 
@@ -60,5 +68,5 @@
         this.email = email;
         this.mobile = mobile;
-        this.role = "ROLE_REGISTIRAN_PARKIRAC";
+        this.role = "ROLE_REGISTRIRAN_PARKIRAC";
     }
 
@@ -70,5 +78,14 @@
         this.email = email;
         this.mobile = mobile;
-        this.role = "ROLE_REGISTIRAN_PARKIRAC";
+        this.role = "ROLE_REGISTRIRAN_PARKIRAC";
+    }
+
+    public RegistriranParkirac(String name, String surname, String email, String password, String mobile) {
+        this.name = name;
+        this.surname = surname;
+        this.password = password;
+        this.email = email;
+        this.mobile = mobile;
+        this.role = "ROLE_REGISTRIRAN_PARKIRAC";
     }
 
@@ -95,12 +112,4 @@
     public void setSurname(String surname) {
         this.surname = surname;
-    }
-
-    public String getPassword() {
-        return password;
-    }
-
-    public void setPassword(String password) {
-        this.password = password;
     }
 
@@ -132,4 +141,43 @@
 
     public void setRole(String role) {this.role = role;}
+
+    @Override
+    public Collection<? extends GrantedAuthority> getAuthorities() {
+        SimpleGrantedAuthority authority = new SimpleGrantedAuthority(role);
+        return Collections.singleton(authority);
+    }
+
+    public String getPassword() {
+        return password;
+    }
+
+    public void setPassword(String password) {
+        this.password = password;
+    }
+
+    @Override
+    public String getUsername() {
+        return email;
+    }
+
+    @Override
+    public boolean isAccountNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isAccountNonLocked() {
+        return !locked;
+    }
+
+    @Override
+    public boolean isCredentialsNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return enabled;
+    }
 }
 
Index: sources/app/src/main/java/parkup/entities/Vraboten.java
===================================================================
--- sources/app/src/main/java/parkup/entities/Vraboten.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/entities/Vraboten.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -1,13 +1,16 @@
 package parkup.entities;
 
-import parkup.data.Tablicka;
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.userdetails.UserDetails;
+import parkup.data.VrabotenDemo;
 
 import javax.persistence.*;
 import java.util.ArrayList;
+import java.util.Collection;
 import java.util.List;
 
 @Entity
 @Table(name = "vraboten")
-public class Vraboten {
+public class Vraboten implements UserDetails {
     @Id
     @SequenceGenerator(
@@ -49,11 +52,15 @@
     private String status;
 
-    @Column(name = "account")
-    private boolean account;
+    @Column(name="locked")
+    private boolean locked;
+
+    @Column(name = "enabled")
+    private boolean enabled;
+
 
     public Vraboten() {
         this.role = "ROLE_VRABOTEN";
         this.parkingZones = new ArrayList<ParkingZone>();
-        this.account = true;
+        this.enabled = false;
         this.status = "neRaboti";
     }
@@ -68,5 +75,5 @@
         this.parkingZones = parkingZones;
         this.role = "ROLE_VRABOTEN";
-        this.account = true;
+        this.enabled = false;
         this.status = "neRaboti";
     }
@@ -80,6 +87,18 @@
         this.parkingZones = parkingZones;
         this.role = "ROLE_VRABOTEN";
-        this.account = true;
+        this.enabled = false;
         this.status = "neRaboti";
+    }
+
+    public Vraboten(String firstName, String lastName, String email, String password, String mobile) {
+        this.firstName=firstName;
+        this.lastName=lastName;
+        this.email=email;
+        this.password=password;
+        this.mobile=mobile;
+        this.parkingZones=new ArrayList<>();
+        this.enabled=false;
+        this.status="neRaboti";
+        this.role="ROLE_VRABOTEN";
     }
 
@@ -116,8 +135,42 @@
     }
 
+    @Override
+    public Collection<? extends GrantedAuthority> getAuthorities() {
+        return null;
+    }
+
     public String getPassword() {
         return password;
     }
 
+    @Override
+    public String getUsername() {
+        return email;
+    }
+
+    @Override
+    public boolean isAccountNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isAccountNonLocked() {
+        return !locked;
+    }
+
+    public void lockVraboten(){
+        this.locked = !locked;
+    }
+
+    @Override
+    public boolean isCredentialsNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return enabled;
+    }
+
     public void setPassword(String password) {
         this.password = password;
@@ -144,6 +197,6 @@
     public void setStatus(String status) {this.status = status;}
 
-    public boolean isAccount() {return account;}
-
-    public void setAccount(boolean account) {this.account = account;}
+    public boolean isAccount() {return enabled;}
+
+    public void setAccount(boolean account) {this.enabled = account;}
 }
Index: sources/app/src/main/java/parkup/repositories/GuestRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/GuestRepository.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/repositories/GuestRepository.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -3,6 +3,8 @@
 import java.util.Optional;
 import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.stereotype.Repository;
 import parkup.entities.Guest;
 
+@Repository
 public interface GuestRepository extends JpaRepository<Guest, Integer> {
     Guest findByGuestId(int id);
Index: sources/app/src/main/java/parkup/repositories/ParkingZoneRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/ParkingZoneRepository.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/repositories/ParkingZoneRepository.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -2,6 +2,8 @@
 
 import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.stereotype.Repository;
 import parkup.entities.ParkingZone;
 
+@Repository
 public interface ParkingZoneRepository extends JpaRepository<ParkingZone, Integer> {
     ParkingZone findByPzId(int id);
Index: sources/app/src/main/java/parkup/repositories/RegistriranParkiracRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/RegistriranParkiracRepository.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/repositories/RegistriranParkiracRepository.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -3,6 +3,12 @@
 import java.util.Optional;
 import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Modifying;
+import org.springframework.data.jpa.repository.Query;
+import org.springframework.stereotype.Repository;
 import parkup.entities.RegistriranParkirac;
 
+import javax.transaction.Transactional;
+
+@Repository
 public interface RegistriranParkiracRepository extends JpaRepository<RegistriranParkirac, Integer> {
     RegistriranParkirac findByRegParkId(int regParkId);
@@ -11,3 +17,9 @@
 
     Optional<RegistriranParkirac> findRegistriranParkiracByEmail(String email);
+
+    @Transactional
+    @Modifying
+    @Query("UPDATE RegistriranParkirac rp " +
+            "SET rp.enabled = TRUE WHERE rp.email = ?1")
+    int enableRegistriranParkirac(String email);
 }
Index: sources/app/src/main/java/parkup/repositories/VrabotenRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/VrabotenRepository.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/repositories/VrabotenRepository.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -3,6 +3,12 @@
 import java.util.Optional;
 import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Modifying;
+import org.springframework.data.jpa.repository.Query;
+import org.springframework.stereotype.Repository;
 import parkup.entities.Vraboten;
 
+import javax.transaction.Transactional;
+
+@Repository
 public interface VrabotenRepository extends JpaRepository<Vraboten, Integer> {
     Vraboten findByVrabotenId(int id);
@@ -11,3 +17,9 @@
 
     Optional<Vraboten> findVrabotenByEmail(String email);
+
+    @Transactional
+    @Modifying
+    @Query("UPDATE Vraboten v " +
+            "SET v.enabled = TRUE WHERE v.email = ?1")
+    int enableVraboten(String email);
 }
Index: sources/app/src/main/java/parkup/services/AdministratorService.java
===================================================================
--- sources/app/src/main/java/parkup/services/AdministratorService.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/services/AdministratorService.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -1,5 +1,4 @@
 package parkup.services;
 
-import java.time.LocalDateTime;
 import java.util.List;
 import java.util.Objects;
@@ -14,5 +13,4 @@
 import org.springframework.stereotype.Service;
 import parkup.configs.email.EmailValidator;
-import parkup.configs.token.ConfirmationToken;
 import parkup.configs.token.ConfirmationTokenService;
 import parkup.entities.Administrator;
@@ -42,16 +40,22 @@
     }
 
-    public void addAdministrator(Administrator administrator) {
+    public Optional<Administrator> addAdministrator(Administrator administrator) {
         Optional<Administrator> administratorOpt = this.administratorRepository.findAdministratorByEmail(administrator.getEmail());
         if (administratorOpt.isPresent()) {
             throw new IllegalStateException("Email already taken, try adding an administrator with a different valid email address");
         } else {
-            System.out.println(administrator);
-            this.administratorRepository.save(administrator);
+            if (administrator.getEmail() != null && administrator.getEmail().length() > 1 && administrator.getEmail().contains("@")) {
+                //System.out.println(regPark);
+                this.administratorRepository.save(administrator);
+            }
+            else {
+                throw new IllegalStateException("email not valid");
+            }
         }
+        return administratorOpt;
     }
 
     @Transactional
-    public void updateAdministrator(int administratorId, String firstName, String lastName, String mobile, String email) {
+    public Administrator updateAdministrator(int administratorId, String firstName, String lastName, String mobile, String email) {
         Optional<Administrator> administratorOpt = Optional.ofNullable(this.administratorRepository.findByAdministratorId(administratorId));
         if (administratorOpt.isPresent()) {
@@ -62,6 +66,7 @@
                     throw new IllegalStateException("email taken");
                 }
-
                 administratorNov.setEmail(email);
+            }else{
+                throw new IllegalStateException("email not valid");
             }
 
@@ -77,8 +82,13 @@
                 administratorNov.setMobile(mobile);
             }
+            return administratorNov;
         }
+        else {
+            throw new IllegalStateException("Administrator doesn't exist, therefore can't be updated");
+        }
+
     }
 
-    public void deleteAdministrator(int administratorId) {
+    public Optional<Administrator> deleteAdministrator(int administratorId) {
         Optional<Administrator> administratorOpt = Optional.ofNullable(this.administratorRepository.findByAdministratorId(administratorId));
         if (administratorOpt.isPresent()) {
@@ -87,4 +97,5 @@
             throw new IllegalStateException("Administrator doesn't exist, therefore can't be deleted");
         }
+        return administratorOpt;
     }
 
@@ -126,12 +137,12 @@
 
         String token = UUID.randomUUID().toString();
-        ConfirmationToken confirmationToken = new ConfirmationToken(
-                token,
-                LocalDateTime.now(),
-                LocalDateTime.now().plusMinutes(15),
-                administrator
-        );
+        //ConfirmationTokenRP confirmationToken = new ConfirmationTokenRP(
+        //        token,
+        //        LocalDateTime.now(),
+        //        LocalDateTime.now().plusMinutes(15),
+        //        administrator
+        //);
 
-        confirmationTokenService.saveConfirmationToken(confirmationToken);
+        //confirmationTokenService.saveConfirmationToken(confirmationToken);
 
         // TODO: SEND EMAIL
Index: sources/app/src/main/java/parkup/services/ParkingSessionService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingSessionService.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/services/ParkingSessionService.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -3,7 +3,9 @@
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.stereotype.Service;
+import parkup.data.Tablicka;
 import parkup.entities.ParkingSession;
 import parkup.repositories.ParkingSessionRepository;
 
+import javax.transaction.Transactional;
 import java.util.List;
 import java.util.Objects;
@@ -28,8 +30,10 @@
     }
 
-    public void updateParkingSession(int parkingSessionId, String timeStart, String timeEnd) {
+    @Transactional
+    public void updateParkingSession(int parkingSessionId, String timeStart, String timeEnd, Tablicka tablicka) {
         Optional<ParkingSession> parkingSessionOpt = Optional.ofNullable(parkingSessionRepository.findByPssId(parkingSessionId));
         if (parkingSessionOpt.isPresent()) {
             ParkingSession parkingSessionNov = parkingSessionRepository.findByPssId(parkingSessionId);
+
             if(!parkingSessionNov.getTimeStart().equals(timeStart) && !parkingSessionNov.getTimeStart().equals(timeEnd))
                 parkingSessionNov.setTimeStart(timeStart);
@@ -37,11 +41,18 @@
             if(!parkingSessionNov.getTimeEnd().equals(timeEnd) && !parkingSessionNov.getTimeEnd().equals(timeStart))
                 parkingSessionNov.setTimeEnd(timeEnd);
+
+            if(tablicka!=null && !Objects.equals(parkingSessionNov.getTablica(),tablicka)){
+                parkingSessionNov.setTablica(tablicka);
+            }
+        }else{
+            throw new IllegalStateException("The ParkingSession does not exist");
         }
     }
 
-    public void deleteParkingSession(int parkingSessionId) {
+    public Optional<ParkingSession> deleteParkingSession(int parkingSessionId) {
         Optional<ParkingSession> parkingSessionOpt = Optional.ofNullable(parkingSessionRepository.findByPssId(parkingSessionId));
         if (parkingSessionOpt.isPresent()) {
             parkingSessionRepository.deleteByPssId(parkingSessionId);
+            return parkingSessionOpt;
         } else {
             throw new IllegalStateException("ParkingSpace doesn't exist, therefore can't be deleted");
@@ -49,6 +60,6 @@
     }
 
-    public void addParkingSession(ParkingSession parkingSession) {
-        Optional <ParkingSession> parkingSessionOpt = Optional.ofNullable(parkingSessionRepository.findByPssId(parkingSession.getPssId()));
+    public Optional<ParkingSession> addParkingSession(ParkingSession parkingSession) {
+        Optional<ParkingSession> parkingSessionOpt = Optional.ofNullable(parkingSessionRepository.findByPssId(parkingSession.getPssId()));
         if (parkingSessionOpt.isPresent()) {
             throw new IllegalStateException("ID already taken, ParkingSession cannot be added");
@@ -56,4 +67,5 @@
             System.out.println(parkingSession);
             parkingSessionRepository.save(parkingSession);
+            return parkingSessionOpt;
         }
     }
Index: sources/app/src/main/java/parkup/services/ParkingSpaceService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingSpaceService.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/services/ParkingSpaceService.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -6,4 +6,5 @@
 import parkup.repositories.ParkingSpaceRepository;
 
+import javax.transaction.Transactional;
 import java.util.List;
 import java.util.Objects;
@@ -28,6 +29,6 @@
     }
 
-    public void addParkingSpace(ParkingSpace parkingSpace) {
-        Optional <ParkingSpace> parkingSpaceOpt = Optional.ofNullable(parkingSpaceRepository.findByPsName(parkingSpace.getPsName()));
+    public Optional<ParkingSpace> addParkingSpace(ParkingSpace parkingSpace) {
+        Optional<ParkingSpace> parkingSpaceOpt = Optional.ofNullable(parkingSpaceRepository.findByPsName(parkingSpace.getPsName()));
         if (parkingSpaceOpt.isPresent()) {
             throw new IllegalStateException("Name already taken, try adding a ParkingZone with a different name");
@@ -36,7 +37,9 @@
             parkingSpaceRepository.save(parkingSpace);
         }
+        return parkingSpaceOpt;
     }
 
-    public void updateParkingSpace(int parkingSpaceId, String psName, boolean taken, boolean handicaped) {
+    @Transactional
+    public ParkingSpace updateParkingSpace(int parkingSpaceId, String psName, boolean taken, boolean handicaped, float lat, float lng) {
         Optional<ParkingSpace> ParkingSpaceOpt = Optional.ofNullable(parkingSpaceRepository.findByPsId(parkingSpaceId));
         if (ParkingSpaceOpt.isPresent()) {
@@ -58,8 +61,20 @@
                 ParkingSpaceNov.setHandicaped(handicaped);
             }
+
+            if(lat!=0 && !Objects.equals(ParkingSpaceNov.getLat(), lat)){
+                ParkingSpaceNov.setLat(lat);
+            }
+
+            if(lng!=0 && !Objects.equals(ParkingSpaceNov.getLng(), lng)){
+                ParkingSpaceNov.setLng(lng);
+            }
+            return ParkingSpaceNov;
+        }else{
+            throw new IllegalStateException("ParkingSpace does not exist");
         }
     }
 
-    public void deleteParkingSpace(int parkingSpaceId) {
+    @Transactional
+    public Optional<ParkingSpace> deleteParkingSpace(int parkingSpaceId) {
         Optional<ParkingSpace> parkingSpaceOpt = Optional.ofNullable(parkingSpaceRepository.findByPsId(parkingSpaceId));
         if (parkingSpaceOpt.isPresent()) {
@@ -68,4 +83,5 @@
             throw new IllegalStateException("ParkingSpace doesn't exist, therefore can't be deleted");
         }
+        return parkingSpaceOpt;
     }
 }
Index: sources/app/src/main/java/parkup/services/ParkingZoneService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingZoneService.java	(revision ce6ad22249e902dea17e6ba473846ccebdd4330c)
+++ sources/app/src/main/java/parkup/services/ParkingZoneService.java	(revision f6bc52d991e03ece15d64dc62eaeb0f2aed0805b)
@@ -2,10 +2,13 @@
 
 import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.data.jpa.repository.Modifying;
 import org.springframework.stereotype.Service;
-import parkup.entities.Administrator;
+import parkup.data.ParkingZoneLocation;
+import parkup.entities.ParkingSpace;
 import parkup.entities.ParkingZone;
 import parkup.repositories.ParkingZoneRepository;
 
 import javax.transaction.Transactional;
+import java.util.ArrayList;
 import java.util.List;
 import java.util.Objects;
@@ -30,5 +33,14 @@
     }
 
-    public void addParkingZone(ParkingZone parkingZone) {   //zavisno vo koj grad ili opstina i napravi proverki pred dodavanje, implementiraj u naredna faza
+    public List<String> getAllParkingZoneNames() {
+        List<ParkingZone> parkingZones = this.parkingZoneRepository.findAll();
+        List<String> parkingZonesNames = new ArrayList<>();
+        for (ParkingZone pz : parkingZones){
+            parkingZonesNames.add(pz.getPzName());
+        }
+        return parkingZonesNames;
+    }
+
+    public Optional<ParkingZone> addParkingZone(ParkingZone parkingZone) {   //zavisno vo koj grad ili opstina i napravi proverki pred dodavanje, implementiraj u naredna faza
         Optional<ParkingZone> parkingZoneOpt = Optional.ofNullable(parkingZoneRepository.findByPzName(parkingZone.getPzName()));
         if (parkingZoneOpt.isPresent()) {
@@ -38,8 +50,23 @@
             parkingZoneRepository.save(parkingZone);
         }
+        return parkingZoneOpt;
     }
 
+    public ParkingZone addParkingZoneNameOnly(String name) {
+        Optional<ParkingZone> parkingZoneOpt = Optional.ofNullable(parkingZoneRepository.findByPzName(name));
+        if (parkingZoneOpt.isPresent()) {
+            throw new IllegalStateException("Name already taken, try adding a ParkingZone with a different name");
+        } else {
+            ParkingZone parkingZone = new ParkingZone(name.trim());
+            parkingZoneRepository.save(parkingZone);
+            return parkingZone;
+        }
+    }
+
+    //TODO prati niza od objekti ParkingSpaces i prati objekt ParkingZoneLocation
     @Transactional
-    public void updateParkingZone(int parkingZoneId, String pzName, int price, int capacity, String workHours, String location) {
+    public ParkingZone updateParkingZone(int parkingZoneId, String pzName, int price, int capacity,
+                                         String location, int from, int to, String color,
+                                         List<ParkingSpace> parkingSpaces, ParkingZoneLocation parkingZoneLocation) {
         Optional<ParkingZone> parkingZoneOpt = Optional.ofNullable(parkingZoneRepository.findByPzId(parkingZoneId));
         if (parkingZoneOpt.isPresent()) {
@@ -62,15 +89,37 @@
             }
 
-            if (workHours != null && workHours.length() > 0 && !Objects.equals(parkingZoneNov.getWorkHours(), workHours)) {
-                parkingZoneNov.setWorkHours(workHours);
-            }
-
             if (location != null && location.length() > 0 && !Objects.equals(parkingZoneNov.getLocation(), location)) {
                 parkingZoneNov.setLocation(location);
             }
+
+            if (from != 0 && !Objects.equals(parkingZoneNov.getFrom(), from)) {
+                parkingZoneNov.setFrom(from);
+            }
+
+            if (to != 0 && !Objects.equals(parkingZoneNov.getTo(), to)) {
+                parkingZoneNov.setTo(to);
+            }
+
+            if (color != null && color.length() > 0 && !Objects.equals(parkingZoneNov.getColor(), color)) {
+                parkingZoneNov.setColor(color);
+            }
+
+            if(parkingZoneLocation!=null){
+                parkingZoneNov.setParkingZoneLocation(parkingZoneLocation);
+            }
+
+            if(!parkingSpaces.isEmpty()){
+                //TODO kreiraj lista od parkingSpaces, ni gi prakja false isHandicaped i isTaken
+                parkingZoneNov.setParkingSpaces(parkingSpaces);
+            }
+
+            return parkingZoneNov;
+        } else {
+            throw new IllegalStateException("There ParkingZone does not exist");
         }
     }
 
-    public void deleteParkingZone(int parkingZoneId) {
+    @Transactional
+    public Optional<ParkingZone> deleteParkingZone(int parkingZoneId) {
         Optional<ParkingZone> parkingZoneOpt = Optional.ofNullable(parkingZoneRepository.findByPzId(parkingZoneId));
         if (parkingZoneOpt.isPresent()) {
@@ -79,4 +128,5 @@
             throw new IllegalStateException("ParkingZone doesn't exist, therefore can't be deleted");
         }
+        return parkingZoneOpt;
     }
 }
